package com.goafanti.common.dao;

import com.goafanti.app.bo.ProjectBo;
import com.goafanti.app.bo.ProjectDetailBo;
import com.goafanti.business.bo.BusinessProjectBo;
import com.goafanti.common.model.BusinessCategory;
import com.goafanti.common.model.BusinessProject;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BusinessProject)表数据库访问层
 *
 * @author makejava
 * @since 2024-09-19 14:54:12
 */
public interface BusinessProjectMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BusinessProject selectById(String id);

    

    /**
     * 查询指定行数据
     *
     * @param businessProject 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<BusinessProject> findBusinessProjectList(BusinessProject businessProject, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param businessProject 查询条件
     * @return 总行数
     */
    int findBusinessProjectCount(BusinessProject businessProject);

    /**
     * 新增数据
     *
     * @param businessProject 实例对象
     * @return 影响行数
     */
    int insert(BusinessProject businessProject);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BusinessProject> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BusinessProject> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BusinessProject> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BusinessProject> entities);

    /**
     * 修改数据
     *
     * @param businessProject 实例对象
     * @return 影响行数
     */
    int update(BusinessProject businessProject);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(String id);

    int insertSelective(BusinessProject record);



    int getBnamecount(String bname);

    String getCreateName(String id);

    BusinessProject selectByPrimaryBname(String bname);

    List<ProjectBo> getBusinessProject(String id);

    ProjectDetailBo selectAppProjectDetail(String id);

    int checkProject(String id);

    List<BusinessProjectBo> selectBusinessProjectByName(@Param("businessName")String businessName, @Param("cname")String cname);

    List<BusinessProjectBo> selectByFirstBName(@Param("businessName") String businessName, @Param("type") Integer type);

    List<BusinessCategory> selectBusinessProjectCatalog();


    /**
     * @return
     */
    List<Map> selectProjectAndTypeAll();


    BusinessProject selectByTid(Integer tid);

}

